/******************************************************************************
* DISCLAIMER

* This software is supplied by Renesas Technology Corp. and is only 
* intended for use with Renesas products. No other uses are authorized.

* This software is owned by Renesas Technology Corp. and is protected under 
* all applicable laws, including copyright laws.

* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES 
* REGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, 
* INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A 
* PARTICULAR PURPOSE AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY 
* DISCLAIMED.

* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* TECHNOLOGY CORP. NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES 
* FOR ANY REASON RELATED TO THE THIS SOFTWARE, EVEN IF RENESAS OR ITS 
* AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

* Renesas reserves the right, without notice, to make changes to this 
* software and to discontinue the availability of this software.  
* By using this software, you agree to the additional terms and 
* conditions found by accessing the following link:
* http://www.renesas.com/disclaimer
********************************************************************************
* Copyright (C) 2009. Renesas Technology Corp., All Rights Reserved.           *
********************************************************************************/

/*""FILE COMMENT""*********** Technical reference data *************************
 *
 *       System Name : SH7264 USB FUNCTION Sample Program
 *       File Name   : main.c
 *       Abstract    : Sample Program Main
 *       Version     : 1.03.00
 *       Device      : SH7264/SH7262
 *       Tool-Chain  : High-performance Embedded Workshop (Ver.4.04.01).
 *                   : C/C++ compiler package for the SuperH RISC engine family
 *                   :                             (Ver.9.02 Release00).
 *       OS          : None
 *       H/W Platform: M3A-HS64G50(CPU board)
 *
 *       History   : May.13.2009 ver.1.00.00
 *                 : Jul.06.2009 ver.1.01.00 Changed common directory
 *                 : Jul.13.2009 ver.1.02.00 Tool-Chain 9.2.0.0
 *                 : Nov.10.2009 ver.1.03.00 Changed common directory
 *""FILE COMMENT END""**********************************************************/
#include <stdio.h>
#include <string.h>
#include <machine.h>
#include <mathf.h>
#include "iodefine.h"       /* SH7264 iodefine  */
#include "m3a_hs64.h"
#include "usb.h"
#include "usb_firm.h"
#include "common.h"



/* ---- MMf[^ 2ʂ݂ɓւċpp---- */
#ifdef FORMAT_1702
// 1M_q`l̑S2ĎgpB CDATAAhX̊JnAvH
// 3bytef[^@SSI_DATASIZE3 oCgǂݍŁ@f[^̂肩珇ԂɁ@4btyef[^ɓWJB
  #pragma section CDATA
  unsigned long Data0[2][(SSI_DATASIZE * 2)/4];  
  #pragma section
  
  int format_1702_flag;

#else
//  V3ʂ4{̃f[^荞݂ƂĎg
#pragma section CDATA
  unsigned long Data0[3][(SSI_DATASIZE + BUF_SIZE_USB0)/4];  
#pragma section
#endif


unsigned int BuffIdx0,BuffIdx1;   // Data0[BuffIdx][]
unsigned int BuffIdx_bulkin;
unsigned int BuffIdx_bulkin_old;
unsigned int BuffIdx3,BuffIdx_bulkin3,BuffIdx_bulkin3_old;  

/*----- bulkout message ------*/
unsigned char message_bulkout[5][2];



//***********************************
// fobOpPCɃf[^𑗂邽߂̃IvVB
#define DEBUG6 1
#ifdef  DEBUG6 
union {
	float f0;
	char   c0[4];
} ufc0;

union {
	short  s0;
	char   c0[2];
} usc0;

int not_init_zero;
#endif

union {
	int i0;
	char   c0[4];
} uic0;

#ifdef  DEBUG6 
unsigned char msg0[257];
#else
unsigned char msg0[65];
#endif


/* {TvOĐtO */
int double_speed0;

/* NSSI3 ́@USBRg[̐؂ւPB22XCb`ōsB*/
int USB_INPUT0;

/*   AUDIO CLOCK ؂ւtO */
int  audio_clk0;


/* ==== vg^Cv錾 ==== */
void init_ssif(void);
void change_ssi2_bck();
void io_init_dma1(void *src, void *rsrc, void *dst, void *src2, void *dst2, void *rdst2, void *src3, void *rsrc3, void *dst3);
void set_data0(void);

#define BULK_OUT_PIPE	PIPE1
#define BULK_IN_PIPE	PIPE2
#define INTR_IN_PIPE	PIPE6


extern int CDC_start_snd( unsigned long size, unsigned char *top );
extern int CDC_start_rcv( unsigned long size, unsigned char *buf );
extern int CDC_check_complete( unsigned short Pipe );
extern void CDC_snd_char(unsigned char c);



extern unsigned char		LineCodingItem[];
// /*	Line Coding Structure	*/
// unsigned char		LineCodingItem[] = {
//	0x00,0xC2,0x01,0x00,	/*	0-3	dwDTERate 	Bit Rate(bps)	Default : 0x1C200 (115200)	*/
//	0x00,					/*	 4	bCharFormat Stop BIt		Default : 0 (1 Stop bit)	*/
//	0x00,					/*	 5	bCharFormat Parity			Default : 0 (None )			*/
//	0x08,					/*	 6	bCharFormat Data Bit		Default : 8					*/
//	0x00					/*	 7	bCharFormat Flow Control	Default : 0 (SW or None)	*/
//};

#ifdef LCI2
unsigned char		LineCodingItem2[8];
#endif


/*""FUNC COMMENT""*******************************************************
 * Outline     : main
 *-----------------------------------------------------------------------
 * Include     : 
 *-----------------------------------------------------------------------
 * Declaration : void main(void);
 *-----------------------------------------------------------------------
 * Description : 
 *-----------------------------------------------------------------------
 * Argument    : void
 *-----------------------------------------------------------------------
 * Return Value: void
 *-----------------------------------------------------------------------
 * Notice      : 
 *""FUNC COMMENT END""***************************************************/
 

void main(void)
{	
	int i, f, l;
    unsigned long l_SSI_DATASIZE;
	unsigned char c, *p, *pout;
	int count0,size0,count2;
    unsigned long *in1, *out1;
    unsigned long ux1,ux2;
      

        /* AUDIO CLK pɃ}`vbNXݒ */
	    PORT.PECR0.BIT.PE0MD	= 2;	/* AUDIO CLK */
        audio_clk0=0;  // when 1, audio clk

        /* PB21 ɒǉLED̐̂߂̏ݒ */
		/* ƕt^ɂƂƂĂLED̐̂߂̏ */
		/* PG14ɒǉLED̐̂߂̏ݒ  */
	    /*--- PBCR5ݒ PB21̐ݒ ---*/	
	    PORT.PBCR5.WORD &= 0xFF0Fu;
		PORT.PCCR2.WORD &= 0xFFF0u;
#ifdef YLED0
		PORT.PGCR3.WORD &= 0xF0FFu;
#endif
    	/*--- PBIOR1ݒ PB21LEDo͂ɐݒ ---*/
	    PORT.PBIOR1.WORD |= 0x0020u;
		PORT.PCIOR0.WORD |= 0x0100u;
#ifdef YLED0
		PORT.PGIOR0.WORD |= 0x4000u;
#endif	
     	/*--- PBDR1ݒ PB21Low ---*/
     	PORT.PBDR1.BYTE.L &= 0xDFu;
		PORT.PCDR0.BYTE.H &= 0xFEu;
#ifdef YLED0
		PORT.PGDR0.BYTE.H &= 0xBFu;
		// FLED@	
		PORT.PGDR0.BYTE.H |= 0x40u;	
#endif


                /* 2{TvOĐǂ */
		 double_speed0=0;
		 

         USB_INPUT0=1;		 

	  
    	/* f[^̏  */
		set_data0();



     
       /*-- DMAC ̏ݒ ---- */
	  /*  SSI2M   SSI3M   SSI1M  */
	   BuffIdx0 = 0u;	   
       BuffIdx1 = 1u;  
	   BuffIdx3 = 0u;
       io_init_dma1( Data0[0], Data0[1], (void *)&SSIF2.SSIFTDR,  (void *)&SSIF3.SSIFRDR, Data0[1], Data0[0],   (Data0[0]+SSI_DATASIZE2), (Data0[1]+SSI_DATASIZE2), (void *)&SSIF1.SSIFTDR);
       
	   /*-- SSI ̏ݒ ---- */ 
       init_ssif();	   
	   
	   
	   // SSI3 ̓͂̂Ƃ͂őҋ@
	   if( USB_INPUT0 != 1)
	   {
		   /*--- 荞ݗD惌xݒ ---*/
           INTC.IPR10.BIT._CMT0 = 0x1;
	       set_imask( 0 ); 
		   /*--- [v ---*/
	       while(1){

		   }
	   }



	   
	  /*-- USB bulkout ̃bZ[W --*/
	   message_bulkout[0][0]=0x30;
	   message_bulkout[1][0]=0x31;   		
	   message_bulkout[2][0]=0x32;
	   message_bulkout[3][0]=0x33;  
	   
#ifdef LCI2
      for(f=0;f<8;++f) LineCodingItem2[f]=0;
#endif	



#ifdef FORMAT_1702
         format_1702_flag=1;   //change to default as format 1702
		 l_SSI_DATASIZE = SSI_DATASIZE3;  // 3oCgf[^ǂށB
#else
         l_SSI_DATASIZE = SSI_DATASIZE;		 
#endif	
	
	P_ModeInit();

#ifndef USB_ONLY0
        io_init_scif2();
#endif

#ifdef DEBUG6
/////       not_init_zero=1;  //Ƀf[^ɃZbgȂB
#endif   

                   // PC珑ޑOɏ
                   LineCodingItem[4]=0;

                   //ʂɏ
                   audio_clk0=0;  // set normal 
                   double_speed0=0;

                   //ēx
                   change_ssi2_bck();
//-------------------------------------------------------------------------------
re_start0:
                         
   			// FLED@
#ifdef YLED0			
			PORT.PGDR0.BYTE.H |= 0x40u;	
#endif		

			
                        count2=0;
                        //////l_SSI_DATASIZE = SSI_DATASIZE;
                        /////audio_clk0=0;  // set normal 
                        ////format_1702_flag=0;
                        ////double_speed0=0;


#ifdef LCI2
   LineCodingItem2[7]=0;   // flow ɃZbgB
#endif		
						
   // HOST@PC̋NMiXgbvrbgPȏj҂B
f=0;
   while(1){
	
     // WHILE[v́@LED@tbVB
    if( f < 0x10000 ) { PORT.PGDR0.BYTE.H &= 0xBFu; ++f;}  // for debug Yellow Led Light Up	
    else if( f < 0x20000)  { PORT.PGDR0.BYTE.H |= 0x40u; ++f;} // for debug Yellow Led Light Down
     else f=0;
	 
	 if((LineCodingItem[4] == 12) || (LineCodingItem[4] == 13))
     {
       double_speed0=2;
#ifdef AUDIO_CLK_USE 
	   if(LineCodingItem[4] == 13) audio_clk0=1;
           else audio_clk0=0;
#endif

#ifdef FORMAT_1702
       if( format_1702_flag >= 1)   l_SSI_DATASIZE = SSI_DATASIZE3;  // 3oCgf[^ǂށB 
       else l_SSI_DATASIZE = SSI_DATASIZE;
#endif

       change_ssi2_bck();
	   break;
     }
     else if((LineCodingItem[4] == 14) || (LineCodingItem[4] == 15))
     {
       double_speed0=4;
#ifdef AUDIO_CLK_USE 
	   if(LineCodingItem[4] == 15) audio_clk0=1;
           else audio_clk0=0;
#endif

#ifdef FORMAT_1702
       if( format_1702_flag >= 1)   l_SSI_DATASIZE = SSI_DATASIZE3;  // 3oCgf[^ǂށB 
       else l_SSI_DATASIZE = SSI_DATASIZE;
#endif
       change_ssi2_bck();
	   break;
     }
     else if( (LineCodingItem[4] == 11) || (LineCodingItem[4] == 10))
     {
       double_speed0=1;
#ifdef AUDIO_CLK_USE 
	   if(LineCodingItem[4] == 10) audio_clk0=1;
           else audio_clk0=0;
#endif

#ifdef FORMAT_1702
       if( format_1702_flag >= 1)   l_SSI_DATASIZE = SSI_DATASIZE3;  // 3oCgf[^ǂށB 
       else l_SSI_DATASIZE = SSI_DATASIZE;
#endif

       change_ssi2_bck();
	   break;
     }


#ifdef DEBUG6	 
	 else if(LineCodingItem[4] == 6) // fboOpPCɃf[^𑗂B
	 {

                                         f=0;
			//msg0[0]=0x66; f++;    // data type float
                                        msg0[0]=0x69; f++;    // data type int
                                        //msg0[0]=0x73; f++;    // data type short
			for(i=0;i<63;++i)
			{
                                         // ufc0.f0= kaiser_lpf1[2 * i];
		               // ufc0.f0= works2[i];		
					   
                        if( i < 16) uic0.i0= Data0[0][i] ;	//8bit + SHIFT0 @Ƃɖ߂	
                        else if( i < 32) uic0.i0= Data0[0][i-16 + SSI_DATASIZE2] ;
			else if( i < 48) uic0.i0 = Data0[1][i-32];  // 32data1
			else  uic0.i0 = Data0[1][i-48+ SSI_DATASIZE2];  // 48Ԉȍ~data1
			
                        for(l=0;l<4;++l)
			 {
			 // msg0[1+4*i+l]=ufc0.c0[l];	
                                              msg0[1+4*i+l]=uic0.c0[l];
                                              f++;
			 }
			}
				
	        //------ USB bZ[W̑M -----
	          CDC_start_snd(f,msg0);
	           
	       
       
       /////double_speed0=1;
       not_init_zero=1;  // 2ڂ́AData0ŏ㏑ȂB
       change_ssi2_bck();
	   break;	 

	 }	 
#endif

#ifdef FORMAT_1702
    // LineCodingItem[4]O@ҋ@ԂŁ@V
	// format_1702 1[hɂȂ
    // LineCodingItem[4]O@ҋ@ԂŁ@9
	// format_1702 2[hɂȂ	
	// LineCodingItem[4]O@ҋ@ԂŁ@8Ɖ
    else if( LineCodingItem[4] == 7)   // 20bit
	{ 
         format_1702_flag=1;
         l_SSI_DATASIZE = SSI_DATASIZE3;  // 3oCgf[^ǂށB
         break;
	}
	else if( LineCodingItem[4] == 5)   // 18bit
	{ 
         format_1702_flag=2;
         l_SSI_DATASIZE = SSI_DATASIZE3;  // 3oCgf[^ǂށB
         change_ssi2_bck();
         break;
	}
	else if( LineCodingItem[4] == 9)   // 24bit
	{ 
         format_1702_flag=3;
         l_SSI_DATASIZE = SSI_DATASIZE3;  // 3oCgf[^ǂށB  
         change_ssi2_bck();
         break;
	}
        else if( LineCodingItem[4] == 8)
	{ 
         format_1702_flag=0;
         l_SSI_DATASIZE = SSI_DATASIZE;  
         change_ssi2_bck();
         break;
	}	
	
	
#endif
	  else if(LineCodingItem[4] > 0) break; 
   }   // HOST@PC̋NMiXgbvrbgPȏj҂B while(1){


/*  BuffIdx Zbg */	
    BuffIdx_bulkin=BuffIdx0;
    BuffIdx_bulkin3=BuffIdx3;
////    ͂߂͓ǂݍ io_init_dma Ă΂ĕς܂ő҂ƂɂĂ݂
    BuffIdx_bulkin_old=BuffIdx_bulkin;	
    BuffIdx_bulkin3_old=BuffIdx_bulkin3;
////	BuffIdx_bulkin^= 1u; 
////    BuffIdx_bulkin3^= 1u;	
	

// t^ɂƂƂĂLED 
   PORT.PCDR0.BYTE.H |= 0x01u;
   //////LineCodingItem[7]=1;  // for debug   This Line was pass !--------------------
   
   			// FLED@
#ifdef YLED0			
			PORT.PGDR0.BYTE.H |= 0x40u;	
#endif	   
	



/*    USB@f[^̓ǂݍ݂̌JԂ@@@*/	
while(1){  //@
	 
	 
#ifdef LCI2
     //  for(f=0;f<8;++f) LineCodingItem2[f]=LineCodingItem[f];
 #ifdef GET_SSI_STATE
      //flow bit ƃ{[[ǵ@Rs[ȂB
      // [0]= SSI1 IDST1
      // [1]= SSI2 IDST2
      // [2}= SSI1 FIFO ̐ + 8 if DMAC1 COUNT STOP
      // [3]= SSI2 FIFO ̐ + 8 if DMAC3 COUNT STOP
      //
      for(f=4;f<7;++f) LineCodingItem2[f]=LineCodingItem[f];
 #else
      // flow bit ́@Rs[ȂB
      //for(f=0;f<7;++f) LineCodingItem2[f]=LineCodingItem[f];
 #endif 
#endif
	 
	//  HOST@PĆiXgbvrbgOjҋ@ցB
	if(LineCodingItem[4] == 0)
	{
#ifdef DEBUG6 
             // 6̂Ƃ, not_init_zeroPɂ́Af[^𑗂̗㏑ȂB
             if(not_init_zero ==0) set_data0();
#else
		set_data0();
#endif
		goto re_start0;
	}


#ifdef LCI2
       ////LineCodingItem2[0]=BuffIdx_bulkin_old;
       ////LineCodingItem2[1]=BuffIdx_bulkin;
	   if( format_1702_flag > 0) LineCodingItem2[7]=message_bulkout[BuffIdx_bulkin + 2 ][0];
	   else LineCodingItem2[7]=message_bulkout[BuffIdx_bulkin ][0];
#endif
//#define Use_GetLineCode 1  //ONƓȂȂB

#ifdef Use_GetLineCode
      // flow control btye ɂł
      // 
         if( format_1702_flag > 0) f=2; else f=0;
          // LineCodingItem[]ɒڏނƂȂȂIH
          //set_flow (message_bulkout[BuffIdx_bulkin + f ][0]);	
		  LineCodingItem[7]=message_bulkout[BuffIdx_bulkin + f ][0];
#endif


	if(  BuffIdx_bulkin_old != BuffIdx_bulkin) // A
	{	
	  BuffIdx_bulkin_old=BuffIdx_bulkin;

        //ÂQ@bulkin3؂ւĂ邩`FbN
        for( l=20000; l >0; l--) { /* 1.1ms = (1/44.1KHz ) * 32 bit * 1.5 cyc * 16/20 */
        /* wait */  if( BuffIdx_bulkin3_old != BuffIdx_bulkin3)  goto next0; }
         goto re_start0;   
   next0:BuffIdx_bulkin3_old  = BuffIdx_bulkin3;

		  
         p=(unsigned char *)Data0[BuffIdx_bulkin]; 
	  
	  
	 //t^ɂƂƂĂLED_ 
	 PORT.PCDR0.BYTE.H &= 0xFEu;
	 //////////////////////////////////////
	 
#ifdef LCI2
       ////LineCodingItem2[0]=BuffIdx_bulkin_old;
       ////LineCodingItem2[1]=BuffIdx_bulkin;
	   if( format_1702_flag > 0) LineCodingItem2[7]=message_bulkout[BuffIdx_bulkin + 2 ][0];
	   else LineCodingItem2[7]=message_bulkout[BuffIdx_bulkin ][0];
#endif	 
	 
#ifdef Use_GetLineCode
      // flow control btye ɂł
      // AɓƂ̏̍XV
         if( format_1702_flag > 0) f=2; else f=0;
	 LineCodingItem2[7]=message_bulkout[BuffIdx_bulkin + f ][0];	
#endif	 
	 /*------ USB bZ[W̑M -----*/ 

#ifdef LCI2
#define WAIT_HOST_ACTION_TIME  0x100000    // 0x300000
#else

#ifdef Use_GetLineCode
#define WAIT_HOST_ACTION_TIME  0x100000    // 0x300000
#else
#define WAIT_HOST_ACTION_TIME  0x300000    // 0x100000
#endif

#endif

     if( LineCodingItem[5] == 3)
     {
       // peB[3̂Ƃ́@bZ[W𑗐MȂB
     }
     else
     { 
	 l=0;
	 while(1){
          if( format_1702_flag > 0) f=2; else f=0;
	  if( CDC_start_snd(1,message_bulkout[BuffIdx_bulkin + f]) == 0) break;
	  if(l> WAIT_HOST_ACTION_TIME ) { break; } else{ ++l; }
	 }	
	 /*------ bZ[W̑M܂ő҂ -----*/
	 l=0;

	 while( !(CDC_check_complete(BULK_IN_PIPE)) ){	 		 
	  if(l> WAIT_HOST_ACTION_TIME ) { break; } else{ ++l; }
		/* wait */
	 }	
       }
 
	 count0=0;	 f=0;  	 
	 while( count0 < l_SSI_DATASIZE )
	 {
	     /*------ USB f[^̎M -----*/ 
	     l=0;
	      while(1){
	      if( CDC_start_rcv(BUF_SIZE_USB0,p) == 0) break;	  
           if(l > 0x200000) { break; } else{ ++l;++f;}
	     }	
	     /*------ f[^M܂ő҂ -----*/
	     l=0;
	      while( !(CDC_check_complete(BULK_OUT_PIPE)) ){
		    if(l> 0x100000) { break; } 	else{ ++l; ++f;}
	      	/* wait */
	     }			 

		  
		 size0 = BUF_SIZE_USB0 - USBDataCount[ BULK_OUT_PIPE ];
	     count0 +=size0;
		 p += size0;
		
		 if(f > 0x200000) { break; } 
	 }
	 
	 if( count0 >= l_SSI_DATASIZE) {


#ifdef FORMAT_1702
#define SHIFT0  4    // (24-SHIFT0)=20
#define SHIFT1  12  // SHIFT0+8
#define SHIFT2  28  // 24+SHIFT0
#define SHIFT3  4  // 8 - SHIFT0
#define SHIFT4  12   // 16 - SHIFT0
#define SHIFT5  20   // 16 + SHIFT0
#define SHIFT6 12  // SHIFT0+8

         // 3oCgf[^肩珇ԂɂSoCgf[^ɓWJB
        if( format_1702_flag == 1)
       {
               /****
               out1 = (Data0[BuffIdx_bulkin] + SSI_DATA_SIZE22 -1);
               p = (unsigned char *)Data0[BuffIdx_bulkin];
               pout = (unsigned char *)Data0[BuffIdx_bulkin];
               p += (SSI_DATASIZE3 - 1);
               pout += (SSI_DATA_SIZE24 - 1);
               uic0.i0=0;
               for(f=0;f<SSI_DATA_SIZE22;++f)   
               {
                   for(l=0;l<3;++l) 
                   { 
                      ////*(pout--) = *(p--);
                      uic0.c0[3-l]= *p; p--;
                   }
                   ////*(pout--) = 0x00;
                   uic0.i0 = uic0.i0>>SHIFT0;
                   *out1 = uic0.i0;  out1--;
               }
               ***/
               in1 =  (Data0[BuffIdx_bulkin] + SSI_DATASIZE34 -1);
               out1 = (Data0[BuffIdx_bulkin] + SSI_DATA_SIZE22 -1);
               for(f=0;f<SSI_DATA_SIZE23;++f)   
               {
                  ux1= *in1--;  // 3/3
				  ux2= *in1--;  // 2/3
                  *out1-- = (ux1 >> SHIFT0);      //4th
                  *out1-- = ((ux2 << SHIFT3) | ((ux1 & 0xff000000) >> SHIFT2) );   //3th
                  ux1=*in1--;   // 1/3
                  *out1-- = (((ux1 & 0x000000ff) << SHIFT4  ) | ((ux2 & 0xffff0000) >> SHIFT5));  // 2nd
                  *out1-- = (ux1 >> SHIFT6);   // 1st 
               }


       }  //  if( format_1702_flag == 1)
	   
#define SHIFT0b  6    // (24-SHIFT0)=18bit
#define SHIFT1b  14  // SHIFT0+8
#define SHIFT2b  30  // 24+SHIFT0
#define SHIFT3b  2  // 8 - SHIFT0
#define SHIFT4b  10   // 16 - SHIFT0
#define SHIFT5b  22   // 16 + SHIFT0
#define SHIFT6b 14  // SHIFT0+8	   
	   
	   else if( format_1702_flag == 2)
	   {
		   
              in1 =  (Data0[BuffIdx_bulkin] + SSI_DATASIZE34 -1);
               out1 = (Data0[BuffIdx_bulkin] + SSI_DATA_SIZE22 -1);
               for(f=0;f<SSI_DATA_SIZE23;++f)   
               {
                  ux1= *in1--;  // 3/3
				  ux2= *in1--;  // 2/3
                  *out1-- = (ux1 >> SHIFT0b);      //4th
                  *out1-- = ((ux2 << SHIFT3b) | ((ux1 & 0xff000000) >> SHIFT2b) );   //3th
                  ux1=*in1--;   // 1/3
                  *out1-- = (((ux1 & 0x000000ff) << SHIFT4b  ) | ((ux2 & 0xffff0000) >> SHIFT5b));  // 2nd
                  *out1-- = (ux1 >> SHIFT6b);   // 1st 
               }		   
		   
	   }
#define SHIFT0c  0    // (24-SHIFT0)=24bit
#define SHIFT1c  8  // SHIFT0+8
#define SHIFT2c  24  // 24+SHIFT0
#define SHIFT3c  0  // 8 - SHIFT0
#define SHIFT4c  16   // 16 - SHIFT0
#define SHIFT5c  16   // 16 + SHIFT0
#define SHIFT6c  8  // SHIFT0+8	
	   else if( format_1702_flag == 3)
	   {
		   
              in1 =  (Data0[BuffIdx_bulkin] + SSI_DATASIZE34 -1);
               out1 = (Data0[BuffIdx_bulkin] + SSI_DATA_SIZE22 -1);
               for(f=0;f<SSI_DATA_SIZE23;++f)   
               {
                  ux1= *in1--;  // 3/3
				  ux2= *in1--;  // 2/3
                  *out1-- = ux1 ;      //4th
                  *out1-- = ( ux2  | ((ux1 & 0xff000000) >> SHIFT2c) );   //3th
                  ux1=*in1--;   // 1/3
                  *out1-- = (((ux1 & 0x000000ff) << SHIFT4c  ) | ((ux2 & 0xffff0000) >> SHIFT5c));  // 2nd
                  *out1-- = (ux1 >> SHIFT6c);   // 1st 
               }		   
		   
	   }	   
#endif
	     /*--- PBDR1ݒ PB21Low ---*/
	     /* LED@ */
                  PORT.PBDR1.BYTE.L &= 0xDFu;  

#ifdef FORMAT_1702
			// FLED@_
#ifdef YLED0			
			PORT.PGDR0.BYTE.H &= 0xBFu;	
#endif
#endif


			  
	 }
	 else
	 {
        count2=0; 
#ifdef FIFO_DMA_OUT
               //  IɎMI点B
               /* D0FIFO DMA stop   */
               DMAC.CHCR5.BIT.DE    = 0;		/* DMA transfer disabled */
               DMAC.CHCR5.BIT.TE     = 0;		/* Transfer end flag clear */
               if( DMAC.CHCR5.BIT.TS == 0 ) {
		         PipeDataSize[BULK_OUT_PIPE] -= DMAC.DMATCR5.LONG;			/* 8bit		*/
	            }
	            else if( DMAC.CHCR5.BIT.TS == 1 ){
		         PipeDataSize[BULK_OUT_PIPE] -= (DMAC.DMATCR5.LONG * 2);			/* 16bit	*/
               }
	            else if( DMAC.CHCR5.BIT.TS == 2 ){
		         PipeDataSize[BULK_OUT_PIPE] -= (DMAC.DMATCR5.LONG * 4);			/* 32bit	*/
	           }
	           USB.D0FIFOSEL.BIT.DREQE = 0;     // DMAN֎~
               USB.D0FIFOCTR.WORD = BITBCLR;    // obt@NA[
               PipeFlag[BULK_OUT_PIPE] = PIPE_DONE;
		     
#endif


             // ۂɎMf[^zXgPC֑B 
             f=0;

		     msg0[0]=0x69; f++;   // char i
             uic0.i0=	count0;			
			 for(l=0;l<4;++l)
			 {
			  msg0[1+l]=uic0.c0[l];	
			  f++;
			 }				 
	        /*------ USB bZ[W̑M -----*/ 
	        l=0;
	        while(1){
	           if( CDC_start_snd(f,msg0) == 0) break;
	           if(l>0x100000) { break; } else{ ++l; }
			}          
	 
	 }
 
	 
	 
        // t^ɂƂƂĂLED 
		PORT.PCDR0.BYTE.H |= 0x01u;
		///////////////////////////////////////
		 

	
	// ̓ǂݍ݂	
	} // A
 }//@

}

/* DMA1 p@SSI2@ւ̑M荞ݏ@*/
void io_int_dma1(void)
{
     volatile unsigned long dummy;	 
	 
	  /* DMA ][hݒ */
      DMAC.RSAR1.LONG= (unsigned long)Data0[BuffIdx0]; /* ---- DMA [h\[XAhXWX^̐ݒ ---- */    
 
#ifdef FORMAT_1702 
      if( format_1702_flag >= 1)
	    DMAC.RDMATCR1.LONG= SSI_DATASIZE2 ;	  
	  else
#endif
        DMAC.RDMATCR1.LONG= SSI_DATASIZE2 ;


 
	  /*---- USB bulkin Data0[] index ----*/
	  BuffIdx_bulkin=BuffIdx0;	 

	  /* ---- Mobt@̃CfbNXXV ---- */
      BuffIdx0 ^= 1u;
	 
	  
	  
	  /*--- PBDR1ݒ PB21High ---*/
	  /* LED@ */
      PORT.PBDR1.BYTE.L |= 0x20u;
	
	 
	 	 
     /* ---- gXt@GhtONA ---- */
     DMAC.CHCR1.BIT.TE = 0u;
      dummy = DMAC.CHCR1.BIT.TE; /* _~[[h */



}

#ifdef FORMAT_1702
void io_int_dma3(void)
{
     volatile unsigned long dummy;	 
	 

	  /* SSI1p DMA3 ][hݒ */
      DMAC.RSAR3.LONG= (unsigned long)(Data0[BuffIdx3] + SSI_DATASIZE2); /* ---- DMA [h\[XAhXWX^̐ݒ ---- */    
     

      if( format_1702_flag >= 1)
	    DMAC.RDMATCR3.LONG= SSI_DATASIZE2 ;	 
      else
	    DMAC.RDMATCR3.LONG= SSI_DATASIZE2 ;

 
	  /*---- USB bulkin Data0[] index ----*/
	  BuffIdx_bulkin3=BuffIdx3;	 

	  /* ---- Mobt@̃CfbNXXV ---- */
      BuffIdx3 ^= 1u;
	 
	  
	  
	  /*--- ݒ  ---*/		
         // FLED@	
	 PORT.PGDR0.BYTE.H |= 0x40u;	
	
	 
	 	 
     /* ---- gXt@GhtONA ---- */
     DMAC.CHCR3.BIT.TE = 0u;
      dummy = DMAC.CHCR3.BIT.TE; /* _~[[h */



}
#endif


#ifdef SSI3_INPUT
/* DMA2 p@SSI3@̎M荞ݏ@*/
void io_int_dma2(void)
{
     volatile unsigned long dummy;	 
	 
	  /* DMA ][hݒ */
      DMAC.RDAR2.LONG= (unsigned long)Data0[BuffIdx1]; /* ---- DMA [hfXeBl[VAhXWX^̐ݒ ---- */    
      DMAC.RDMATCR2.LONG= SSI_DATASIZE2 ;
	  
	  /* ---- Mobt@̃CfbNXXV ---- */
      BuffIdx1 ^= 1u;
	 	 
	  /*--- PBDR1ݒ PB21Low ---*/
	  /* LED@ */
      PORT.PBDR1.BYTE.L &= 0xDFu;	 
	  	 
		 
     /* ---- gXt@GhtONA ---- */
     DMAC.CHCR2.BIT.TE = 0u;
      dummy = DMAC.CHCR2.BIT.TE; /* _~[[h */
}
#endif


#define FREQ0 1000
#define SIN_F0_FS   0.141994318 
#define COS_F0_FS   0.989867472


void set_data0(void)
{
   unsigned long i,ix0;
   float y0,y1,y2;
  
   
 
#ifdef FORMAT_1702
   for(i=0;i<SSI_DATA_SIZE22;++i)
   {
#else   
   for(i=0;i<SSI_DATASIZE2;++i)
   {
#endif

#ifdef INIT_SIN_1KHZ	   
	   if(i==0 )
	   {
	      y0=0.;
		  y1=0.;	   
	   }
	   else if(i==1)
	   {
		  y0= SIN_F0_FS;
		  y2=y1;
		  y1=y0;
		     
	   }
	   else
	   {
	      y0= 2.0 * COS_F0_FS * y1 - y2;
		  y2=y1;
		  y1=y0;
	   }
	   y0=y0*32767.;
	   ix0=(int)y0;
#else
       ix0=0x0000u;
#endif	   
	   Data0[0][i]=ix0<<16;
	   Data0[0][i]+=ix0;
	   Data0[1][i]=0; //Data0[0][i];
   }
      
   //y0=sin(0.1);

}



/* End of File */
